Subject: Re: Gittorent .. avahi ?

From: "Shawn O. Pearce" <[email-masked]>
Date: Tue, 3 Apr 2007 01:31:45 -0400

Sam Vilain <[email-masked]> wrote:
...
> I think in BitTorrent there is an *over*-emphasis on making the tracker
> load light, because people want to be able to run them on the most
> dirt-cheap hosting account they can find, because they might get shut
> down and don't want a huge outlay.  But with GitTorrent, a large number
> of the tracker providers are going to be software houses, and people
> already running mirroring services - and so the increased load will be
> more than justified by the reduced overall load.
...

Yes, I agree entirely.  Almost anyone who is going to be running a
tracker for GitTorrent would already today be running the anonymous
Git daemon.  These users (ahm... kernel.org) would like to reduce
load on their servers if clients can get the data from elsewhere.
Hosting a tracker is still load, but should be a *much* lower load.

Note that kernel.org's entire load appears to be disk IO (as stated
by hpa on many occasions).  A little bit of extra CPU and network
bandwidth (for tracker maintenance) to cut disk IO in half (due to
less object directory accesses) would probably be major improvement
for them, and would still cut their overall network bandwidth as
clients would get packs from other nodes in the P2P system.

> Anyway, the old warning about scope creep applies to this idea - working
> from the bottom up is a lot better for getting things done than thinking
> big.  Just look at me, I think big all the time and never get anything
> done ;-)  There will be a lot of interesting technologies enabled by
> gittorrent.

I agree.  The biggest risk to any GSoC project is not the student,
or the community, or the technology... but its scope creep.
Of course this is true of *any* project.

Git evolved.  Linux evolved.  Apache evolved.  None of them set
out on day one with a huge list of "must have" features that they
coded from scratch.  Every one of those projects organically grew
as new features were desired and old bugs fixed.[*1*]

[*1*] Yes, I know, Linus did set out when writing both Linux and
      Git to create something that did X... but X was a pretty
      small concept.  Git started as a "track Linus' state thing",
      not as a full SCM.  ;-)

-- 
Shawn.